/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FAMILIASALO                                              */
/* Tabela : FAMILIASALO                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 01/01/2006 - Joo Paulo Reis                                               */
/*                                                                            */
/******************************************************************************/


CREATE OR REPLACE TRIGGER DTULTATU_FAMILIASALDO
BEFORE INSERT OR UPDATE OR DELETE
ON FAMILIASALDO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUFAMS := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFAMILISALD,0) <> NVL(:NEW.CDFAMILISALD,0)) OR
         (NVL(:OLD.NMFAMILISALD,0) <> NVL(:NEW.NMFAMILISALD,0)) THEN
         :NEW.DTULTATUFAMS := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('FAMILIASALDO', '', 'CDFAMILISALD='||:OLD.CDFAMILISALD||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE FAMILIASALDO MODIFY DTULTATUFAMS DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_FAMILIASALDO','4.11.169'); END;
/

